/*
 * Header file for version information
 *
 * Copyright 2005 Andi Jahja <xharbour@cbn.net.id>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.txt.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA (or visit the web site https://www.gnu.org/).
 *
 * As a special exception, the Harbour Project gives permission for
 * additional uses of the text contained in its release of Harbour.
 *
 * The exception is that, if you link the Harbour libraries with other
 * files to produce an executable, this does not by itself cause the
 * resulting executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of
 * linking the Harbour library code into it.
 *
 * This exception does not however invalidate any other reasons why
 * the executable file might be covered by the GNU General Public License.
 *
 * This exception applies only to the code released by the Harbour
 * Project under the name Harbour.  If you copy code from other
 * Harbour Project or Free Software Foundation releases into a copy of
 * Harbour, as the General Public License permits, the exception does
 * not apply to the code that you add in this way.  To avoid misleading
 * anyone as to the status of such modified files, you must delete
 * this exception notice from them.
 *
 * If you write modifications of your own for Harbour, it is your choice
 * whether to permit this exception to apply to your modifications.
 * If you do not wish that, delete this exception notice.
 *
 */

#ifndef HB_VERX_CH_
#define HB_VERX_CH_

#define _HB_VER_MAJOR                1  /* int   */
#define _HB_VER_MINOR                2  /* int   */
#define _HB_VER_REVISION             3  /* int   */
#define _HB_VER_LEX                  4  /* char  */
#define _HB_VER_AS_STRING            5  /* char  */
#define _HB_PCODE_VER                6  /* int   */
#define _HB_VER_COMPILER             7  /* char  */
#define _HB_VER_PLATFORM             8  /* char  */
#define _HB_VER_BUILD_DATE           9  /* char  */
#define _HB_VER_BUILD_TIME          10  /* char  */
#define _HB_VER_LENTRY              11  /* char  */
#define _HB_VER_CHLCVS              12  /* char  */
#define _HB_VER_C_USR               13  /* char  */
#define _HB_VER_L_USR               14  /* char  */
#define _HB_VER_PRG_USR             15  /* char  */
#define _HB_EXTENSION               16  /* bool  */
#define _HB_C52_UNDOC               17  /* bool  */
#define _HB_C52_STRICT              18  /* bool  */
#define _HB_COMPAT_C53              19  /* bool  */
#define _HB_COMPAT_XPP              20  /* bool  */
#define _HB_COMPAT_VO               21  /* bool  */
#define _HB_COMPAT_FLAGSHIP         22  /* bool  */
#define _HB_COMPAT_FOXPRO           23  /* bool  */
#define _HB_COMPAT_DBASE            24  /* bool  */
#define _HB_HARBOUR_OBJ_GENERATION  25  /* bool  */
#define _HB_HARBOUR_STRICT_ANSI_C   26  /* bool  */
#define _HB_CPLUSPLUS               27  /* bool  */
#define _HB_HARBOUR_YYDEBUG         28  /* bool  */
#define _HB_SYMBOL_NAME_LEN         29  /* int   */
#define _HB_MULTITHREAD             30  /* bool  */
#define _HB_VM_OPTIMIZATION         31  /* int   */
#define _HB_LANG_ID                 32  /* char  */
#define _HB_ARRAY_MODE              33  /* int   */
#define _HB_CREDITS                 34  /* array */
#define _HB_VER_LAST                35  /* last  */

#endif /* HB_VERX_CH_ */
